
--This file provides trigonometric inverses functions + some other 
--mathematical functions.
--The accuracy of the inverse function is set up with the procedure set_error
--Name of function is self explanatory 
--Usual constant are also provided 
--This release 0.0 as not been extensively checked

global constant Pi=3.14159265359
global constant Exp=2.718281828459
global constant Log10=2.302585092994

atom estimate, current_error,Error 

global procedure set_error(atom er)
Error=er
end procedure

global function abs(atom x)
if x<0 then return (-x)
 else
 return x
end if
end function

type sincos(atom x)
return  abs(x)<=1
end type

type positive(atom x)
 return x>=0
end type

global function arctan(atom tg)
 estimate=remainder(tg,Pi)
 current_error=tg-tan(estimate)
 while abs(current_error) >= Error do
 estimate=remainder(estimate+(current_error*power(cos(estimate),2)),Pi)
 current_error=tg-tan(estimate)
 end while
 return estimate
end function

global function arcsin(sincos sn)
 estimate=remainder(sn,Pi)
 current_error=sn-sin(estimate)
 if sn=1 then return Pi/2 end if
 if sn=-1 then return -Pi/2 end if
 if abs(sn)!=1 then
 while abs(current_error) >= Error do
 estimate=remainder(estimate+(current_error/cos(estimate)),Pi)
 current_error=sn-sin(estimate)
 end while
 return estimate
 end if 
end function

global function arcos(sincos cs)
 if cs=1 then return 0 end if
 if cs=-1 then return Pi end if
 if abs(cs)!=1 then
 if cs<0.5 then estimate=sqrt(1+2*cs)
 else
 estimate=1.0
 end if
 current_error=cs-cos(estimate)
 while abs(current_error) >= Error do
 estimate=remainder(estimate-(current_error/sin(estimate)),Pi)
 current_error=cs-cos(estimate)
 end while
 return estimate
 end if
end function

global function exp(atom x)
 return power(Exp,x)
end function

global function nthroot(atom x,atom pwr)  
 if positive(x) then
 return power(x,(1/pwr))
 else
 return power(-1,pwr)*power(abs(x),(1/pwr))
 end if
end function

global function power10(atom x)
return power(10,x)
end function

global function log10(positive x)
 return log(x)/Log10
end function
 

 


   
